#include "MenuState.h"
#include "GameManager.h"

#include <CEGUI.h>
#include <OgreCEGUIRenderer.h>

MenuState::MenuState()
{

}

MenuState::~MenuState()
{

}

void MenuState::enter()
{
  printf("entering menustate!!!!\n");

  vRoot = Ogre::Root::getSingletonPtr();

  Ogre::Camera *d_camera;
  Ogre::RenderWindow *win;
  Ogre::SceneManager *sm;

  win = vRoot->getAutoCreatedWindow();

  sm = vRoot->createSceneManager(Ogre::ST_GENERIC);
  d_camera = sm->createCamera("PlayerCam");
  d_camera->setPosition(Ogre::Vector3(0,0,500));
  d_camera->lookAt(Ogre::Vector3(0,0,-300));
  d_camera->setNearClipDistance(5);
  
  // Create a viewport covering whole window
  Ogre::Viewport* vp = win->addViewport(d_camera);
  vp->setBackgroundColour(Ogre::ColourValue(255,0,0));

  // Update the camera aspect ratio to that of the viewport
  d_camera->setAspectRatio(Ogre::Real(vp->getActualWidth()) / Ogre::Real(vp->getActualHeight()));

  // Initialisation Area
  CEGUI::OgreCEGUIRenderer* tGUIRenderer = new CEGUI::OgreCEGUIRenderer(win, Ogre::RENDER_QUEUE_OVERLAY, false, 0, sm);
  CEGUI::System* tGUISystem = new CEGUI::System(tGUIRenderer);
  
  CEGUI::SchemeManager::getSingleton().loadScheme((CEGUI::utf8*)"TaharezLook.scheme");
  tGUISystem->setDefaultMouseCursor((CEGUI::utf8*)"TaharezLook", (CEGUI::utf8*)"MouseArrow");
  CEGUI::Window* tRootWindow= CEGUI::WindowManager::getSingleton().createWindow((CEGUI::utf8*)"DefaultWindow", (CEGUI::utf8*)"RootWindow");  
  tGUISystem->setGUISheet(tRootWindow); // set active Window

  
}

void MenuState::exit()
{
  printf("exiting state\n");
}

bool MenuState::frameStarted(const Ogre::FrameEvent &evt) 
{
  CEGUI::System::getSingleton().renderGUI();
  return true;
}

bool MenuState::frameEnded(const Ogre::FrameEvent &evt)
{

  return true;
}
  
